'============================================================================================
'Skrypt Receptury.vbs.
'Skrypt wykonywany jest jako akcja operatorska za pomoc przycisku na masce technologicznej.
'Skrypt moe zosta wywoany z parametrem bdcym nazw receptury.
'Jeli skrypt zosta wywoany bez parametru, to zostanie otwarte okno dialogowe pozwalajce
'operatorowi wprowadzi nazw receptury.
'Na podstawie nazwy receptury odczytywane s z bazy danych nastawy procesu technologicznego.
'Nastawy te s nastpnie wysyane do procesu technologicznego.
'============================================================================================

'Wczytanie definicji nazw symbolicznych wartoci liczbowych uywanych w czasie tworzenia bazy
WczytajSymbole "adovbs.inc"

Dim LancuchPolaczenia '"Connection string" uywany do specyfikacji dostpu do bazy

'Ponisz defincj acucha dostpu do bazy naley dostosowa do aktualnej konfiguracji
'LancuchPolaczenia = "Provider=SQLOLEDB.1;Data Source = MTAB2;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=Receptury"
LancuchPolaczenia = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Receptury.mdb"

Dim Nazwa, Timeout

If Asix.Script.Arguments.Count <> 0 Then
   'Nazwa skryptu jest podana jako argument (parametr) skryptu
   Nazwa = Asix.Script.Arguments(1)
Else
   'Skrypt zosta uruchomiony bez adnego parametru. Naley otworzy okno dialogowe do ktrego
   'operator wprowadzi nazw skryptu
   'Na czas oczekiwania na odpowied operatora neley wyczy kontrol czasu wykonywania 
   'skryptu (timeout).
   Timeout = Asix.Script.Timeout  'Zapamitanie aktualnej wartoci timeout'u
   Asix.Script.Timeout = 0        'Wyczenie kontroli czasu wykonania skryptu
   Nazwa = InputBox("Wprowad nazw receptury:", "Nowa receptura", "Receptura1") 
   Asix.Script.Timeout = Timeout  'Przywrcenie kontroli czasu skryptu w oparciu o zapamitany timeout
End If

If Nazwa <> "" Then       'Jeli operator wprowadzi nazw to "Nazwa" jest rna od ""
   Set Panel = Asix.Panel

   Set AktRecept   = Asix.Variables("AktRecept")  'zmienna zawierajca nazw aktualnej receptury

   'Cztery ponisze zmienne steruj procesem technologicznym
   Set Temperatura = Asix.Variables("Temperatura")
   Set Tlen        = Asix.Variables("Tlen")
   Set Woda        = Asix.Variables("Woda")
   Set Siarka      = Asix.Variables("Siarka")

   'Otwarcie poczenia z baz
   Set Polaczenie = CreateObject("ADODB.Connection")
   Polaczenie.Open LancuchPolaczenia
      
   'Utworzenie pustego zbioru rekordw
   Set Receptury = CreateObject("ADODB.Recordset")

   'Odczyt receptur z tabeli "Receptury   
   Receptury.ActiveConnection = Polaczenie
   Receptury.CursorLocation   = adUseClient
   Receptury.CursorType       = adOpenKeyset
   Receptury.LockType         = adLockOptimistic
   Receptury.Source           = "Receptury"
   Receptury.Open

   'Wyszukanie receptury o podanej nazwie
   Receptury.MoveFirst
   Receptury.Find "Nazwa = #" & Nazwa & "#"
   If Receptury.EOF Then
      Panel.Error "Nie znaleziono receptury o nazwie " & Nazwa
   Else
      'Wysanie nowych nastaw do sterownika
      Tlen.Value        = Receptury("Tlen")
      Siarka.Value      = Receptury("Siarka")
      Temperatura.Value = Receptury("Temperatura")
      Woda.Value        = Receptury("Woda")

      'aktualizacja zmiennej okrelajcej nazw receptury
      AktRecept.Value   = StringToArray(Nazwa,AktRecept.Info.Count)
      Panel.Message "Ustawiono receptur o nazwie " & Nazwa
   End If
End If

'====================================================================================================
'=========================Procedury pomocnicze=======================================================
'----------------------------------------------------------------------------------------------------
'Procedura wczytuje zawarto pliku okrelonego parametrem oraz wykonuje wczytan zawarto.
'Zakada si, e plik zawiera instrukcje jzyka VBScript. Procedura jest uyteczna w przypadku
'plikw zawierajce definicje nazw symbolicznych dla wartoci numerycznych. Uycie nazw symbolicznych
'zamiast wartoci liczbowych poprawia czytelno skryptu.
'Parametry skryptu:
'                   nazwa_pliku - nazwa pliku zawierajcego skrypt w jzyku VBScript
'----------------------------------------------------------------------------------------------------
Sub WczytajSymbole( nazwa_pliku )
   Const TylkoDoOdczytu = 1
   Dim fso,plik,symbole
   Set fso  = CreateObject("Scripting.FileSystemObject")
   Set plik = fso.OpenTextFile(nazwa_pliku,TylkoDoOdczytu)
   symbole = plik.ReadAll 'odczyt caej zawartoci pliku zawierajcego skrypt definiujcy symbole
   plik.Close
   Execute symbole 'wykonanie skryptu zawierajcego definicje symboli
End Sub

'----------------------------------------------------------------------------------------------------
'Funkcja ArrayToString.
'Funkcja przeksztaca okrelon parametrem tablic znakw na acuch znakw.
'----------------------------------------------------------------------------------------------------
Function ArrayToString( arr )
   ArrayToString = ""
   For each element in arr
      If element <> 0 Then
         ArrayToString = ArrayToString & Chr(element)
      End If
   Next 
End Function

'----------------------------------------------------------------------------------------------------
'Funkcja StringToArray.
'Funkcja przeksztaca okrelony parametrem acuch znakw na tablic znakw.
'----------------------------------------------------------------------------------------------------
Function StringToArray( string, count )
   Redim arr(count) 
   For i = 0 To count -1
      If i < Len(string) Then 
         arr(i) = Asc(Mid( string, i+1, 1 ))
      Else
         arr(i) = 0
      End If
   Next 
   StringToArray = arr
End Function
