'============================================================================================
'Skrypt Monitor.vbs.
'Skrypt ledzi warto zmiennej "Spaliny" i w chwili przekroczenia dopuszczalnej wartoi
'zapisuje wartoci aktualnych nastaw (receptura) do bazy danych "Zdarzenia". Skrypt zapisuje
'rwnie warto zmiennej spaliny oraz nazw biecej receptury.
'============================================================================================
'Wczytanie definicji nazw symbolicznych wartoci liczbowych uywanych w czasie tworzenia bazy
WczytajSymbole "adovbs.inc"

Set Panel = Asix.Panel
Panel.Message("Monitor spalin")

SpalinySuma = 0
SpalinyIlosc = 0

Set Polaczenie = CreateObject("ADODB.Connection")
Polaczenie.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Zdarzenia.mdb"
'Polaczenie.Open "Provider=SQLOLEDB.1;Data Source = MTAB2;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=Zdarzenia"
      
Set Zdarzenia = CreateObject("ADODB.Recordset")

Zdarzenia.ActiveConnection = Polaczenie
Zdarzenia.CursorLocation   = adUseClient
Zdarzenia.CursorType       = adOpenKeyset
Zdarzenia.LockType         = adLockOptimistic
'Zdarzenia.Source           = "Zdarzenia"
Zdarzenia.Source           = "SELECT TOP 1 * FROM Zdarzenia"
Zdarzenia.Open

Set Spaliny   = Asix.Variables("Spaliny")    'monitorowana zmienna
Set AktRecept = Asix.Variables("AktRecept")  'nazwa aktualnej receptury

'----------------------------------------------------------------------------------------------------
'Ponisze zmienne s skadnikami receptury. Wartoci tych zmiennych s one zapisywane w bazie danych
'po przekroczeniu maksymalnej dopuszczalnej wartoci zmiennej "Spaliny"
'----------------------------------------------------------------------------------------------------
Set Temperatura = Asix.Variables("Temperatura")
Set Tlen        = Asix.Variables("Tlen")
Set Woda        = Asix.Variables("Woda")
Set Siarka      = Asix.Variables("Siarka")

Spaliny.OnRead = GetRef("NowaWartosc") 'przypisanie funkcji NowaWartosc do zmiennej "Spaliny"

call Asix.SetInterval( GetRef("ObliczSrednia"), 60*60*1000, 1 ) 'Wywolanie co 1 godz.

'----------------------------------------------------------------------------------------------------
'Funkcja uruchamiana jest po kadorazowym odczycie zmiennej procesowej o nazwie "Spaliny".
'----------------------------------------------------------------------------------------------------
Function NowaWartosc( val, stat, tim )
   If stat = OPC_QUALITY_GOOD And val > 9 Then
      With Zdarzenia
         .AddNew
         .Fields("Czas")        = tim
         .Fields("Spaliny")     = val
         .Fields("Temperatura") = Temperatura
         .Fields("Tlen")        = Tlen
         .Fields("Woda")        = Woda
         .Fields("Siarka")      = Siarka
         .Fields("Uwagi")       = "Przekroczenie limitu (" & ArrayToString(AktRecept.Value) & ")"
         .Update
      End With
   End If

   If stat = OPC_QUALITY_GOOD Then
      SpalinySuma  = SpalinySuma + val
      SpalinyIlosc = SpalinyIlosc +1
   End If

End Function

Function ObliczSrednia()
   Dim Srednia
   If SpalinyIlosc <> 0 Then
      Srednia = SpalinySuma/SpalinyIlosc
      With Zdarzenia
         .AddNew
         .Fields("Czas")        = Now
         .Fields("Spaliny")     = Srednia
         .Fields("Temperatura") = 0
         .Fields("Tlen")        = 0
         .Fields("Woda")        = 0
         .Fields("Siarka")      = 0
         .Fields("Uwagi")       = "rednia (" & ArrayToString(AktRecept.Value) & ")"  'Srednia (nazwa recpt.)
         .Update
       End With
   SpalinyIlosc = 0
   Srednia = 0
   End If
End Function

'====================================================================================================
'=========================Procedury pomocnicze=======================================================
'----------------------------------------------------------------------------------------------------
'Procedura wczytuje zawarto pliku okrelonego parametrem oraz wykonuje wczytan zawarto.
'Zakada si, e plik zawiera instrukcje jzyka VBScript. Procedura jest uyteczna w przypadku
'plikw zawierajce definicje nazw symbolicznych dla wartoci numerycznych. Uycie nazw symbolicznych
'zamiast wartoci liczbowych poprawia czytelno skryptu.
'Parametry skryptu:
'                   nazwa_pliku - nazwa pliku zawierajcego skrypt w jzyku VBScript
'----------------------------------------------------------------------------------------------------
Sub WczytajSymbole( nazwa_pliku )
   Const TylkoDoOdczytu = 1
   Dim fso,plik,symbole
   Set fso  = CreateObject("Scripting.FileSystemObject")
   Set plik = fso.OpenTextFile(nazwa_pliku,TylkoDoOdczytu)
   symbole = plik.ReadAll 'odczyt caej zawartoci pliku zawierajcego skrypt definiujcy symbole
   plik.Close
   Execute symbole 'wykonanie skryptu zawierajcego definicje symboli
End Sub

'----------------------------------------------------------------------------------------------------
'Funkcja ArrayToString.
'Funkcja przeksztaca okrelon parametrem tablic znakw na acuch znakw.
'----------------------------------------------------------------------------------------------------
Function ArrayToString( arr )
   ArrayToString = ""
   For each element in arr
      If element <> 0 Then
         ArrayToString = ArrayToString & Chr(element)
      End If
   Next 
End Function
