'====================================================================================================
'Skrypt NowaBaza.vbs
'Skrypt tworzy baz o nazwie "Receptury" a nastpnie tabel o takiej samej nazwie.
'Kady rekord tabeli bdzie zawiera nazw receptury oraz wartoci skadajce si na receptur.
'Kady rekord moe rwnie zawiera uwagi w formie dowolnego tekstu.
'====================================================================================================

'Wczytanie definicji nazw symbolicznych wartoci liczbowych uywanych w czasie tworzenia bazy
WczytajSymbole "adovbs.inc"

Dim LancuchPolaczenia '"Connection string" uywany do specyfikacji dostpu do bazy

'Ponisz defincj acucha dostpu do bazy naley dostosowa do aktualnej konfihuracji
LancuchPolaczenia = "Provider=Microsoft.Jet.OLEDB.4.0;"

UtworzBazeITabele "Receptury.mdb", "Receptury"

MsgBox "Zostaa utworzona baza Receptury.mdb"

'====================================================================================================
'====================================================================================================

'----------------------------------------------------------------------------------------------------
'Procedura UtworzBazeITabele tworzy baze i jedn tabel
'Parametry:
'           nazwa_bazy   - nazwa bazy w ktrej naley utworzy tabel
'           nazwa_tabeli - nazwa tabeli ktr naley utworzy
'----------------------------------------------------------------------------------------------------
Sub UtworzBazeITabele(nazwa_bazy, nazwa_tabeli)
   Dim Baza, Klucz, Tabela
   Set Baza   = CreateObject("ADOX.Catalog")
   Set Tabela = CreateObject("ADOX.Table")

   'Utworzenie bazy danych
   Baza.Create LancuchPolaczenia & "Data Source=" & nazwa_bazy

   With Tabela
      .Name = nazwa_tabeli
      ' Tworzenie pl i dodawanie ich do kolekcji Columns tabeli 
      With .Columns
         .Append "Nazwa",       adVarWChar, 15
         .Append "Temperatura", adDouble
         .Append "Tlen",        adDouble
         .Append "Siarka",      adDouble
         .Append "Woda",        addouble
         .Append "Uwagi",       adVarWChar
      End With
      .Columns("Uwagi").Attributes = adColNullable 'ta kolumna moe by pusta
   End With
   
   'Kluczem bdzie pterwsza kolumna czyli "Nazwa"
   Tabela.Keys.Append "Klucz", adKeyPrimary, Tabela.Columns(0).Name

   ' Dodanie nowej tabeli do bazy.
   Baza.Tables.Append Tabela
   Set Baza = Nothing
End Sub

'----------------------------------------------------------------------------------------------------
'Procedura wczytuje zawarto pliku okrelonego parametrem oraz wykonuje wczytan zawarto.
'Zakada si, e plik zawiera instrukcje jzyka VBScript. Procedura jest uyteczna w przypadku
'plikw zawierajce definicje nazw symbolicznych dla wartoci numerycznych. Uycie nazw symbolicznych
'zamiast wartoci liczbowych poprawia czytelno skryptu.
'Parametry skryptu:
'                   nazwa_pliku - nazwa pliku zawierajcego skrypt w jzyku VBScript
'----------------------------------------------------------------------------------------------------
Sub WczytajSymbole( nazwa_pliku )
   Const TylkoDoOdczytu = 1
   Dim fso,plik,symbole
   Set fso  = CreateObject("Scripting.FileSystemObject")
   Set plik = fso.OpenTextFile(nazwa_pliku,TylkoDoOdczytu)
   symbole = plik.ReadAll 'odczyt caej zawartoci pliku zawierajcego skrypt definiujcy symbole
   plik.Close
   Execute symbole 'wykonanie skryptu zawierajcego definicje symboli
End Sub
