'====================================================================================================
'Skrypt NowaBazaSQL.vbs
'Program tworzy baz SQL o nazwie "Receptury" a nastpnie tabel o takiej samej nazwie.
'Kady rekord tabeli bdzie zawiera nazw receptury oraz wartoci skadajce si na receptur.
'Kady rekord moe rwnie zawiera uwagi w formie dowolnego tekstu.
'====================================================================================================

'Wczytanie definicji nazw symbolicznych wartoci liczbowych uywanych w czasie tworzenia bazy
WczytajSymbole "adovbs.inc"

Dim LancuchPolaczenia '"Connection string" uywany do specyfikacji dostpu do bazy

'Ponisz defincj acucha dostpu do bazy naley dostosowa do aktualnej konfihuracji
LancuchPolaczenia = "Provider=SQLOLEDB.1;Data Source = MTAB2;Integrated Security=SSPI;Persist Security Info=False;"

UtworzBazeSQL   "Receptury"                 'Utworzenie bazy o nazwie 'Receptury'
UtworzTabeleSQL "Receptury", "Receptury"    'Utworzenie tabeli o nazwie 'Receptury w bazie 'Receptury'

MsgBox "Zostaa utworzona baza SQL-Receptury"
'====================================================================================================
'====================================================================================================

'----------------------------------------------------------------------------------------------------
'Procedura UtworzTabeleSQL tworzy tabel w wybranej bazie
'Parametry:
'           nazwa_bazy   - nazwa bazy w ktrej naley utworzy tabel
'           nazwa_tabeli - nazwa tabeli ktr naley utworzy
'----------------------------------------------------------------------------------------------------
Sub UtworzTabeleSQL(nazwa_bazy, nazwa_tabeli)
   Dim Baza, Klucz, Tabela
   Set Baza   = CreateObject("ADOX.Catalog")
   Set Tabela = CreateObject("ADOX.Table")

   'Poniszy acuch naley zmodyfikowa odpowiednio do konfguracji bazy SQL
   Baza.ActiveConnection = LancuchPolaczenia & "Initial Catalog=" & nazwa_bazy & ";"

   With Tabela
      .Name = nazwa_tabeli
      ' Tworzenie pl i dodawanie ich do kolekcji Columns tabeli 
      With .Columns
         .Append "Nazwa",       adVarWChar, 15
         .Append "Temperatura", adDouble
         .Append "Tlen",        adDouble
         .Append "Siarka",      adDouble
         .Append "Woda",        addouble
         .Append "Uwagi",       adVarWChar, 50
      End With
      .Columns("Uwagi").Attributes = adColNullable 'ta kolumna moe by pusta
   End With
   
   'Kluczem bdzie pterwsza kolumna czyli "Nazwa"
   Tabela.Keys.Append "Klucz", adKeyPrimary, Tabela.Columns(0).Name

   ' Dodanie nowej tabeli do bazy. Poniewa to bdnie generuje bd, wic zostaa uyta konstrukcja
   ' On Error
   On Error Resume Next
   Baza.Tables.Append Tabela
   If Err.Number <> &H80004002 Then
      MsgBox "Error # " & Hex(Err.Number) & " " & Err.Description
      Exit Sub
   End If
   On Error GoTo 0
   Set Baza = Nothing
End Sub

'----------------------------------------------------------------------------------------------------
'Procedura tworzenia bazy
'Parametry:
'           Nazwa - nazwa bazy ktr naley utworzy
'Poniewa SQL nie posiada zaimplementowanej funkcji 'Create' dla obiektu 'ADOX.Catalog',
'to baza zostanie utworzona poprzez wykonanie komendy jzyka DDL Transaction-SQL.
'----------------------------------------------------------------------------------------------------
Sub UtworzBazeSQL( nazwa )
   Dim Cn, Cmd

   Set Cn  = CreateObject("ADODB.Connection")
   Set Cmd = CreateObject("ADODB.Command")

   'czenie z baz za pomoc "SQLOLEDB".
   cn.ConnectionString = LancuchPolaczenia
   cn.Open

   Set Cmd.ActiveConnection = cn  'Podczenie obiektu "Command" do SQL

   Cmd.CommandType = adCmdText
   Cmd.CommandText = "CREATE DATABASE " & nazwa
   Cmd.Execute  'utworzenie bazy
   Cn.Close
End Sub

'----------------------------------------------------------------------------------------------------
'Procedura wczytuje zawarto pliku okrelonego parametrem oraz wykonuje wczytan zawarto.
'Zakada si, e plik zawiera instrukcje jzyka VBScript. Procedura jest uyteczna w przypadku
'plikw zawierajce definicje nazw symbolicznych dla wartoci numerycznych. Uycie nazw symbolicznych
'zamiast wartoci liczbowych poprawia czytelno skryptu.
'Parametry skryptu:
'                   nazwa_pliku - nazwa pliku zawierajcego skrypt w jzyku VBScript
'----------------------------------------------------------------------------------------------------
Sub WczytajSymbole( nazwa_pliku )
   Const TylkoDoOdczytu = 1
   Dim fso,plik,symbole
   Set fso  = CreateObject("Scripting.FileSystemObject")
   Set plik = fso.OpenTextFile(nazwa_pliku,TylkoDoOdczytu)
   symbole = plik.ReadAll 'odczyt caej zawartoci pliku zawierajcego skrypt definiujcy symbole
   plik.Close
   Execute symbole 'wykonanie skryptu zawierajcego definicje symboli
End Sub
