'============================================================================================
'Skrypt Receptury2.vbs.
'Skrypt ledzi warto zmiennej "NowaRecept". Wartoci tej zmiennej jest nazwa receptury.
'Jeli nazwa receptury jest inna ni nazwa aktualnej receptury, to skrypt odczytuje z bazy danych
'o nazwie "Receptury" z tabeli "Receptury nowe nastawy procesu technologicznego. Nastawy te
's nastpnie wysyane poprzez odpowiednie zmienne systemu ASIX do sterownika.
'============================================================================================
Set Panel = Asix.Panel

'Wczytanie definicji nazw symbolicznych wartoci liczbowych uywanych w czasie tworzenia bazy
WczytajSymbole "adovbs.inc"

'Ponisz defincj acucha dostpu do bazy naley dostosowa do aktualnej konfiguracji
'LancuchPolaczenia = "Provider=SQLOLEDB.1;Data Source = MTAB2;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=Receptury"
LancuchPolaczenia = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Receptury.mdb"

PoprzedniaReceptura = ""

Set AktRecept      = Asix.Variables("AktRecept")     'Aktualna receptura
Set NowaReceptura  = Asix.Variables("NowaRecept")    'Nowa receptura

'Zmienne okrelajce nastawy procesu technologicznego
Set Temperatura    = Asix.Variables("Temperatura")
Set Tlen           = Asix.Variables("Tlen")
Set Woda           = Asix.Variables("Woda")
Set Siarka         = Asix.Variables("Siarka")

NowaReceptura.OnRead = GetRef("GdyNowaReceptura")

Function GdyNowaReceptura( val, stat, tim )
   Dim Nazwa 'nazwa nowej receptury
   Nazwa = ArrayToString(val)
   If UCase(Nazwa) <> UCase(ArrayToString(AktRecept.Value)) And Len(Nazwa) _
               And PoprzedniaReceptura <> Nazwa Then
      'Otwarcie poczenia z baz
      Set Polaczenie = CreateObject("ADODB.Connection")
      Polaczenie.Open LancuchPolaczenia
      
      'Utworzenie pustego zbioru rekordw
      Set Receptury = CreateObject("ADODB.Recordset")

      'Odczyt zawartoci tabeli "Receptury"   
      Receptury.ActiveConnection = Polaczenie
      Receptury.CursorLocation   = adUseClient
      Receptury.CursorType       = adOpenKeyset
      Receptury.LockType         = adLockOptimistic
      Receptury.Source           = "Receptury"
      Receptury.Open

      'Wyszukanie receptury o podanej nazwie
      Receptury.MoveFirst
      Receptury.Find "Nazwa = #" & Nazwa & "#"
      If Receptury.EOF Then
         Panel.Error "Nie znaleziono receptury o nazwie " & Nazwa
      Else
         'Wysanie nowych nastaw do sterownika
         Tlen.Value        = Receptury("Tlen")
         Siarka.Value      = Receptury("Siarka")
         Temperatura.Value = Receptury("Temperatura")
         Woda.Value        = Receptury("Woda")
         AktRecept.Value   = StringToArray(Nazwa,AktRecept.Info.Count)
         Panel.Message "Ustawiono receptur o nazwie " & Nazwa
      End If
   PoprzedniaReceptura = Nazwa
   End If
End Function

'=========================Procedury pomocnicze=======================================================
'----------------------------------------------------------------------------------------------------
'Procedura wczytuje zawarto pliku okrelonego parametrem oraz wykonuje wczytan zawarto.
'Zakada si, e plik zawiera instrukcje jzyka VBScript. Procedura jest uyteczna w przypadku
'plikw zawierajce definicje nazw symbolicznych dla wartoci numerycznych. Uycie nazw symbolicznych
'zamiast wartoci liczbowych poprawia czytelno skryptu.
'Parametry skryptu:
'                   nazwa_pliku - nazwa pliku zawierajcego skrypt w jzyku VBScript
'----------------------------------------------------------------------------------------------------
Sub WczytajSymbole( nazwa_pliku )
   Const TylkoDoOdczytu = 1
   Dim fso,plik,symbole
   Set fso  = CreateObject("Scripting.FileSystemObject")
   Set plik = fso.OpenTextFile(nazwa_pliku,TylkoDoOdczytu)
   symbole = plik.ReadAll 'odczyt caej zawartoci pliku zawierajcego skrypt definiujcy symbole
   plik.Close
   Execute symbole 'wykonanie skryptu zawierajcego definicje symboli
End Sub

'----------------------------------------------------------------------------------------------------
'Funkcja ArrayToString.
'Funkcja przeksztaca okrelon parametrem tablic znakw na acuch znakw.
'----------------------------------------------------------------------------------------------------
Function ArrayToString( arr )
   ArrayToString = ""
   For each element in arr
      If element <> 0 Then
         ArrayToString = ArrayToString & Chr(element)
      End If
   Next 
End Function

'----------------------------------------------------------------------------------------------------
'Funkcja StringToArray.
'Funkcja przeksztaca okrelony parametrem acuch znakw na tablic znakw.
'----------------------------------------------------------------------------------------------------
Function StringToArray( string, count )
   Redim arr(count) 
   For i = 0 To count -1
      If i < Len(string) Then 
         arr(i) = Asc(Mid( string, i+1, 1 ))
      Else
         arr(i) = 0
      End If
   Next 
   StringToArray = arr
End Function
